(* ------------------------------------------------------ *)
(*                   SCANTEST.PAS                         *)
(*      Utility zum Anzeigen der Tastatur-Scancodes       *)
(*                 (c) 1988 TOOLBOX                       *)
(* ------------------------------------------------------ *)
PROGRAM ScanTest;

TYPE Registers =  RECORD CASE INTEGER OF
                1: (ax,bx,cx,dx,bp,si,di,ds,flags: INTEGER);
                2: (al,ah,bl,bh,cl,ch,dl,dh      : BYTE);
                  END;
VAR Regs : Registers;

BEGIN
  ClrScr;
  GotoXY(10,20);
  Write('Abbruch mit <Esc> ');
  REPEAT
    WITH Regs DO BEGIN
      ah := 0;
      Intr($16, Regs);    (* aus dem Puffer lesen *)
      GotoXY(10,10);
      Write('ah: ',ah:3,'   al: ',al:3,'  ASCII: ',Chr(al));
    END;
  UNTIL (Regs.ah = 1) AND (Regs.al = 27);
END.
(* ------------------------------------------------------- *)
