(**********************************************************)
(*                                                        *)
(*                Filename TEST02.PAS                     *)
(*                                                        *)
(*      TOOLBOX-Spezial III  Echtzeitverarbeitung         *)
(*                                                        *)
(*        (C) TOOLBOX und Thomas Lang 1988                *)
(*                                                        *)
(*   Dieses File enthlt das Testprogramm Test02, das     *)
(*   nur Periodic 1 als Aufgabe enthlt. Der Zweck des    *)
(*   Programms ist:                                       *)
(*                                                        *)
(*      1.) die Files Schedul, Utility und Debug          *)
(*          (jeweils Deklarationen und Unterprogramme)    *)
(*          werden insofern berprft, da ziemlich       *)
(*          viele der gebotenen Prozeduren aufgerufen     *)
(*          werden, wenn auch keine Aufgabe auer         *)
(*          Periodic 1 und Debug etwas zu tun haben.      *)
(*                                                        *)
(*      2.) die Konstante fr NullBelastung wird damit    *)
(*          ziemlich genau ermittelt. Dazu mu sie aber   *)
(*          zuerst einen willkrlichen Wert zugewiesen    *)
(*          bekommen.                                     *)
(*                                                        *)
(**********************************************************)

Program Test02;

(*$I SCHEDUL.DCL *)
(*$I UTILITY.DCL *)
(*$I DEBUG.DCL *)
(*$I AUFGABEN.DCL *)
(*$I DEBUG.PAS *)
(*$I UTILITY.PAS *)
(*$I SCHEDUL.PAS *)

(*$I PERIOD1.PAS *)           (* Bearbeitung Periodic1 *)
(*$I SONSTIGE.PAS *)          (* hier Periodic1 als *)
                              (* Kommentar gekennzeichnet *)
                              (* da diese in TestAufgabe *)
                              (* definiert ist *)

Begin                         (* des Testprogramms *)

                              (* erste Aufgabe, alle Mg- *)
                              (* lichkeiten des Schedulers*)
                              (* einmal zu probieren *)
   InitDebug(True,True,True,True,'Nix');
   InitSchedul;
   For IX:=1 To AnzahlHoch Do
      PutHoch(IX);
   For IX:=1 To AnzahlFifo Do
      PutFifo((IX Mod 8)+1,21-IX);
   For IX:=1 To AnzahlPeriodic Do
      PutPerDelta(IX,500.0-50.0*IX);
   Schedul;
                              (* zweite Aufgabe, die Be- *)
                              (* stimmung der Null- *)
                              (* Belastung, ber 10 Min. *)
   InitDebug(True,True,True,True,'Nix');
   InitSchedul;
   PutPerDelta(1,60000.0);
   Schedul;

End.
