* COPROCES.ASM
* Coprocesse in LATTICE C
* f. Motorola 68000
* (C) Roland Mosler & TOOLBOX
*
          XDEF      transfer
          XDEF      newproc

          Section   TEXT

newproc   MOVEA.L   $8(A7),A0           * buffer nach A0
          ADDA.L    $C(A7),A0           * A0 = buffer + size
          MOVE.L    $4(A7),-(A0)        * Rcksprung an Processanfang
          MOVE.L    A7,D0               * A7 Sichern
          MOVEA.L   $10(A7),A1          * proc nach A1
          MOVEA.L   A0,A7               * A7 Neusetzen
          MOVEM.L   D0-D7/A0-A7,(A1)    * Register Sichern
          MOVEA.L   D0,A7               * A7 Rcksetzen
          RTS                           * und zurck

transfer  MOVEA.L   $4(A7),A0           * old nach A0
          MOVEM.L   D0-D7/A0-A7,(A0)    * Alte Register Sichern
          MOVEA.L   $8(A7),A0           * new nach A0
          MOVEM.L   (A0),D0-D7/A0-A7    * Neue Register Laden
          RTS                           * und ab geht die Post
          END
