(*******************************************************)
(*                   LISPDEFS.INC                      *)
(*         Include-Modul des LittleLisp-Systems        *)
(*          (C) 1988 Reinhard Hring & TOOLBOX         *)
(*******************************************************)

CONST { Listen nicht als dotted pairs ausgeben }
      list_format=TRUE;
      { max Tiefe fr rekursive Listenausgabe }
      maxdepth=10;

TYPE objp=^obj;
     pair=RECORD
           car,cdr:objp;
          END;
     lstring=STRING[255];
     string80=STRING[80];
     string20=STRING[20];
     pstr20=^string20;
     pstr80=^string80;
     obj=RECORD
          typ:INTEGER;
          CASE i1:INTEGER OF
            0:(i:INTEGER);
            1:(s:pstr80);
            2:(a:pstr20);
            3:(o:pair);
          END;

VAR null,dummy,base_env,property,g_op:objp;
    dynamic:BOOLEAN;
    p_delayed_obj,p_quote,p_define,p_set,p_lambda,
    p_mlambda,p_dlambda,p_procedure,p_mprocedure,
    p_dprocedure,p_cond,p_if,p_t,p_true,p_else,
    p_begin,p_and,p_or,p_let,p_delay,p_memo_proc  : objp;
    a : lstring;
